aboutsummaryrefslogtreecommitdiffstats
path: root/scripts/functions.sh
diff options
context:
space:
mode:
authorSven Eckelmann <sven@narfation.org>2020-11-22 13:12:09 +0100
committerPetr Štetiar <ynezz@true.cz>2020-12-22 19:11:50 +0100
commit3599ea5263a1a39740948110d96cfccdf409f336 (patch)
tree19167effd8f170cbbaaecdee32cc3cf9d524a901 /scripts/functions.sh
parent622ce713ca246aa465bf28d2a743f96999085ea2 (diff)
downloadupstream-3599ea5263a1a39740948110d96cfccdf409f336.tar.gz
upstream-3599ea5263a1a39740948110d96cfccdf409f336.tar.bz2
upstream-3599ea5263a1a39740948110d96cfccdf409f336.zip
images: Fix sysupgrade.tar for devices with NOR flash
The NOR flash rootfs images stored in a sysupgrade.tar must end with the JFFS2 marker. Otherwise, devices like OpenMesh A42/A62 are not able to calculate the md5sum of the fixed squashfs part and store it inside the u-boot-env. But the commit ee76bd11bbe7 ("images: fix boot failures on NAND with small sub pages") adds up to 1020 0x00 bytes after the 0xdead0de EOF marker. The calculated md5sum will be wrong due do this change and u-boot will fail to boot the newly flashed device with a message like: Validating MD5Sum of 'vmlinux'... Passed! Validating MD5Sum of 'rootfs'... Failed! 583a1b7b54b8601efa64ade42742459b != 8850ee812dfd7638e94083329d5d2781 Data validation failed! and boot the old image again. Since the original change should not change the behavior of NOR images, just check for the deadc0de marker at the end of the squashfs-jffs2 image do avoid the problematic behavior for these images. Fixes: ee76bd11bbe7 ("images: fix boot failures on NAND with small sub pages") Signed-off-by: Sven Eckelmann <sven@narfation.org>
Diffstat (limited to 'scripts/functions.sh')
-rw-r--r--scripts/functions.sh24
1 files changed, 23 insertions, 1 deletions
diff --git a/scripts/functions.sh b/scripts/functions.sh
index 9a7fcde627..ec0618c272 100644
--- a/scripts/functions.sh
+++ b/scripts/functions.sh
@@ -5,6 +5,19 @@ get_magic_word() {
dd if=$1 bs=4 count=1 2>/dev/null | od -A n -N 4 -t x1 | tr -d ' '
}
+get_post_padding_word() {
+ local rootfs_length="$(stat -c%s "$1")"
+ [ "$rootfs_length" -ge 4 ] || return
+ rootfs_length=$((rootfs_length-4))
+
+ # the JFFS2 end marker must be on a 4K boundary (often 64K or 256K)
+ local unaligned_bytes=$((rootfs_length%4096))
+ [ "$unaligned_bytes" = 0 ] || return
+
+ # skip rootfs data except the potential EOF marker
+ dd if="$1" bs=1 skip="$rootfs_length" 2>/dev/null | od -A n -N 4 -t x1 | tr -d ' '
+}
+
get_fs_type() {
local magic_word="$(get_magic_word "$1")"
@@ -13,7 +26,16 @@ get_fs_type() {
echo "ubifs"
;;
"68737173")
- echo "squashfs"
+ local post_padding_word="$(get_post_padding_word "$1")"
+
+ case "$post_padding_word" in
+ "deadc0de")
+ echo "squashfs-jffs2"
+ ;;
+ *)
+ echo "squashfs"
+ ;;
+ esac
;;
*)
echo "unknown"